/**************************************************************

   Program Name:  CJ34b.h		  Version: 2.05
   
   Author:  SS	  				  		  Date:  Jun 18, 2014
   
   Compiled with AVRStudio 6.1
   
   Copyright 2004-2013, SOC Robotics, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2006-2014 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Robotics, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-robotics.com
 */
/*
 * $Log: CJ34b.h,v $
 * Revision 2.05  2014/06/17 16:40:20  SS
 *    Support for CJ34b Smart 4-axis joystick
 *
 */
 
#define  NO     'n'
#define  YES    'y'
#define  ON     1
#define  OFF    'f'
#define  LF	    0x0a
#define  CR	    0x0d
#define  BS     0x08
#define  ESC	0x1b

// Configuration setup
#define FOURAXIS		'4'
#define FIVEAXIS		'5'
#define SIXAXIS			'6'
#define UART0MODEINACTIVE	'i'   // Enables UART0 and disables Green LED use
#define UART0MODEACTIVE 'a'
#define JOYSTICKSWMODE  'a'   // Treat Switch inputs as axis output or joystick input

// Master operating state definition
#define  MAJORREV       2
#define  MINORREV       05
#define  BUILDNO		210

#define  MONITORSTATE   'm'
#define  CONTROLSTATE   'c'

#define	 STARTED        's'
#define	 STOPPED		'e'

// Serial Look ahead parameters
#define  RXRECORDLENGTH		80
#define  RXNUMRECORDS		4

#define  BAUDRATE9600	 259
#define  BAUDRATE19200   129
#define  BAUDRATE38400    64
#define  BAUDRATE115200   21
#define  BAUDRATE230400   10
#define  BAUDRATE460800    4

// ESC character settings
#define    NORMAL		'n'
#define	   CHECKFORESC  'c'

// Joystick definitions
#define  JOYGREENLED  'g'
#define  JOYREDLED    'r'
#define  REPEAT       'r'
#define  NOREPEAT     'n'
#define  JOYCONTINUOUS 'c'
#define  JOYSCROLL	   's'

// SmartLCD definitions
#define  SMARTLCDTWIADDRESS  0x26

// Smart Joystick definitions
#define  SMARTJOYSTICKTWIADDRESS 0x27
#define  SMARTLED1				 '1'
#define	 SMARTLED2				 '2'
#define	 SMARTLED3				 '3'
#define  SMARTLED4				 '4'
#define	 SMARTLEDON				 'o'
#define	 SMARTLEDOFF			 'f'
#define  USECJ14JOYSTICK		 '1'
#define  USECJ34JOYSTICK		 '3'
#define  USECJ34BJOYSTICK		 '4'
#define  CJ34BLEDON				 1
#define  CJ34BLEDOFF			'f'
#define  JOYHYSTERESIS			5
#define  JOYPLUS				'p'
#define  JOYMINUS				'm'
#define  JOYPOSSCALE			0.005
#define  JOYFEEDSCALE			0.04
#define  JOYPOSSCALESLOW		0.001
#define  JOYFEEDSCALESLOW		0.004
#define  JOGFAST				'f'
#define  JOGSLOW				's'
#define  JOYSWITCHRIGHT			0x80
#define  JOYSWITCHLEFT			0x40

#define  JOYSWITCHRIGHTPRESSED  !(smartjoyswitches&0x80)
#define  JOYSWITCHLEFTPRESSED   !(smartjoyswitches&0x40)

// Motor Controller Definitions
#define  MOTORCONTROLLER_X_TWIADDRESS  0x10
#define  MOTORCONTROLLER_Y_TWIADDRESS  0x11
#define  MOTORCONTROLLER_Z_TWIADDRESS  0x12
#define  MOTORCONTROLLER_A_TWIADDRESS  0x13
#define  MOTORCONTROLLER_D_TWIADDRESS  0x14
#define  MOTORCONTROLLER_E_TWIADDRESS  0x15
#define  MOTORCONTROLLER_F_TWIADDRESS  0x16
#define  MOTORCONTROLLER_G_TWIADDRESS  0x17
#define  TWIMESSAGELENGTH    20

// RP12 TWI Address
#define  RP12TWIADDRESS	0x48

// EEPROM waypoint constants
#define  WAYPOINTSTARTADDRESS  400
#define  WAYPOINTENDADDRESS    2047
#define  LOGPOSPTRMAX (2047-402)/16

// Tandem drive mode
#define  TANDEMON       'o'
#define  TANDEMOFF	    'f'

#define  WAVE      'w'
#define  FULL      'f'
#define  HALF      'h'
#define  QUARTER   'q'
#define  EIGTH     '8'
#define  SIXTEENTH '6'

#define  AUXPORT1 1
#define  AUXPORT2 2
#define  AUXPORT3 3
#define  AUXPORT4 4

// CJ34B defines
#define CJ34BGETANALOGS  'a'
#define CJ34BID			 'i'
#define CJ34BLED		 'l'
#define CJ34BLED1		 '1'
#define CJ34BLED2		 '2'
#define CJ34BLED3		 '3'

// PWM1 and PWM2 Mode
#define  ANALOGPWM  'a'
#define  INTPWM		'i'
#define  HARDPWM	'h'
#define  NOPWM		'n'

#define DIRX	AVR32_PIN_PB01
#define STEPX	AVR32_PIN_PB00
#define DIRY	AVR32_PIN_PC05
#define STEPY	AVR32_PIN_PC04
#define DIRZ	AVR32_PIN_PA01
#define STEPZ	AVR32_PIN_PA00
#define DIRA	AVR32_PIN_PA03
#define STEPA	AVR32_PIN_PA02
#define eSTOP	AVR32_PIN_PD21
#define LIMITX	AVR32_PIN_PD30
#define LIMITY	AVR32_PIN_PD29
#define LIMITZ	AVR32_PIN_PD28
#define LIMITA	AVR32_PIN_PD27
#define LIMITB	AVR32_PIN_PD27
#define LIMITC	AVR32_PIN_PD27
#define OUT1	AVR32_PIN_PA20
#define SPINDLE	AVR32_PIN_PA20
#define OUT2	AVR32_PIN_PA21
#define PUMP	AVR32_PIN_PA21
#define OUT3	AVR32_PIN_PA22
#define OUT4	AVR32_PIN_PA23
#define ENABLEX AVR32_PIN_PD14
#define ENABLEY AVR32_PIN_PD13
#define ENABLEZ AVR32_PIN_PD12
#define ENABLEA AVR32_PIN_PD11
#define RESETX  AVR32_PIN_PC22
#define RESETY  AVR32_PIN_PC22
#define RESETZ  AVR32_PIN_PC22
#define RESETA  AVR32_PIN_PC22
#define uSDCS	AVR32_PIN_PD03
#define GREENLEDNO2 AVR32_PIN_PC15
#define FTXD0    AVR32_PIN_PC15
#define FRXD0    AVR32_PIN_PC16
#define FTXD1	 AVR32_PIN_PC17
#define FRXD1    AVR32_PIN_PC18
#define FAN1	 AVR32_PIN_PC19
#define FAN2     AVR32_PIN_PC20

#define  SETSTEPX   gpio_set_pin_high(STEPX)
#define  CLRSTEPX   gpio_set_pin_low(STEPX)
#define  SETDIRX    gpio_set_pin_high(DIRX)
#define  CLRDIRX    gpio_set_pin_low(DIRX)

#define  SETSTEPY   gpio_set_pin_high(STEPY)
#define  CLRSTEPY   gpio_set_pin_low(STEPY)
#define  SETDIRY    gpio_set_pin_high(DIRY)
#define  CLRDIRY    gpio_set_pin_low(DIRY)

#define  SETSTEPZ   gpio_set_pin_high(STEPZ)
#define  CLRSTEPZ   gpio_set_pin_low(STEPZ)
#define  SETDIRZ    gpio_set_pin_high(DIRZ)
#define  CLRDIRZ    gpio_set_pin_low(DIRZ)

// Hexapod
#define  SETSTEPA   gpio_set_pin_high(STEPA)
#define  CLRSTEPA   gpio_set_pin_low(STEPA)
#define  SETDIRA    gpio_set_pin_high(DIRA)
#define  CLRDIRA    gpio_set_pin_low(DIRA)

#define  SETSTEPB   gpio_set_pin_high(OUT3)
#define  CLRSTEPB   gpio_set_pin_low(OUT3)
#define  SETDIRB    gpio_set_pin_high(OUT4)
#define  CLRDIRB    gpio_set_pin_low(OUT4)

#define  SETSTEPC   gpio_set_pin_high(OUT1)
#define  CLRSTEPC   gpio_set_pin_low(OUT1)
#define  SETDIRC    gpio_set_pin_high(OUT2)
#define  CLRDIRC    gpio_set_pin_low(OUT2)

#define  SETOUT1    gpio_set_pin_high(OUT1)
#define  CLROUT1    gpio_set_pin_low(OUT1)
#define  SETOUT2    gpio_set_pin_high(OUT2)
#define  CLROUT2    gpio_set_pin_low(OUT2)
#define  SETOUT3    gpio_set_pin_high(OUT3)
#define  CLROUT3    gpio_set_pin_low(OUT3)
#define  SETOUT4    gpio_set_pin_high(OUT4)
#define  CLROUT4    gpio_set_pin_low(OUT4)

#define  SETFAN1    gpio_set_pin_high(FAN1)
#define  CLRFAN1    gpio_set_pin_low(FAN1)
#define  SETFAN2    gpio_set_pin_high(FAN2)
#define  CLRFAN2    gpio_set_pin_low(FAN2)

#define  GRNLED2	'2'

#define  GRNLEDON	gpio_set_pin_low(AVR32_PIN_PC21)
#define  GRNLEDOFF  gpio_set_pin_high(AVR32_PIN_PC21)
#define  REDLEDON	gpio_set_pin_low(AVR32_PIN_PA19)
#define  REDLEDOFF	gpio_set_pin_high(AVR32_PIN_PA19)
#define  GRNLED2ON  gpio_set_pin_low(AVR32_PIN_PC15)
#define  GRNLED2OFF	gpio_set_pin_high(AVR32_PIN_PC15)

// ADC Setup
#define EXAMPLE_ADCIFA_NUMBER_OF_SEQUENCE     6

#define JOY_ADC_CHANNEL_0		0
#define JOY_ADC_FUNCTION_0		AVR32_ADCIN0_FUNCTION
#define JOY_ADC_PIN_0			AVR32_ADCIN0_PIN
#define JOY_ADC_INP_0			AVR32_ADCIFA_INP_ADCIN0
#define JOY_ADC_INN_0			AVR32_ADCIFA_INN_GNDANA
#define JOY_ADC_CHANNEL_1		1
#define JOY_ADC_FUNCTION_1		AVR32_ADCIN1_FUNCTION
#define JOY_ADC_PIN_1			AVR32_ADCIN1_PIN
#define JOY_ADC_INP_1			AVR32_ADCIFA_INP_ADCIN1
#define JOY_ADC_INN_1			AVR32_ADCIFA_INN_GNDANA
#define JOY_ADC_CHANNEL_2		2
#define JOY_ADC_FUNCTION_2		AVR32_ADCIN2_FUNCTION
#define JOY_ADC_PIN_2			AVR32_ADCIN2_PIN
#define JOY_ADC_INP_2			AVR32_ADCIFA_INP_ADCIN2
#define JOY_ADC_INN_2			AVR32_ADCIFA_INN_GNDANA
#define JOY_ADC_CHANNEL_3		3
#define JOY_ADC_FUNCTION_3		AVR32_ADCIN3_FUNCTION
#define JOY_ADC_PIN_3			AVR32_ADCIN3_PIN
#define JOY_ADC_INP_3			AVR32_ADCIFA_INP_ADCIN3
#define JOY_ADC_INN_3			AVR32_ADCIFA_INN_GNDANA
#define JOY_ADC_CHANNEL_4		4
#define JOY_ADC_FUNCTION_4		AVR32_ADCIN4_FUNCTION
#define JOY_ADC_PIN_4			AVR32_ADCIN4_PIN
#define JOY_ADC_INP_4			AVR32_ADCIFA_INP_ADCIN4
#define JOY_ADC_INN_4			AVR32_ADCIFA_INN_GNDANA
#define JOY_ADC_CHANNEL_5		5
#define JOY_ADC_FUNCTION_5		AVR32_ADCIN5_FUNCTION
#define JOY_ADC_PIN_5			AVR32_ADCIN5_PIN
#define JOY_ADC_INP_5			AVR32_ADCIFA_INP_ADCIN5
#define JOY_ADC_INN_5			AVR32_ADCIFA_INN_GNDANA

#ifdef __cplusplus
extern "C" {
	#endif
	
	void Delaymsec(int duration);
	int getchar3nw(void);
	unsigned char getchar3(void);
	void CJ34b_Led(char led,char state);
	void CJ34b_LEDS(char state);
	void CJ34b_Leds_Toggle(int toggles,int duration);
	void CJ34B_Read_SwitchJoy(void);
	int Check_CJ34B_Present(void);
	void Check_SmartLimit_Present(void);
	void Enumerate_Serial_Devices(void);
	void Enumerate_Smart_LimitSwitches(void);
#ifdef __cplusplus
}
#endif


