/**************************************************************

   Program Title:  GenY32 GRBL Port
   
   Program Name:  typedefs.h	 Version: 1.00
   
   Author:  ALD	  					  Date:  May 10, 2014
   
   Compiled with AVR Studio 6.1.2730
   
   This file contains various type definitions to allow gluing
   different code bases together.
   
   Copyright 2014, Tony da Costa  All rights reserved.
   
****************************************************************/
/*
 * Copyright 2014, Tony da Costa  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TONY DA COSTA AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

/*
 * typedefs.h
 *
 * Created: 03/05/2014 2:48:45 PM
 *  Author: tdacosta
 */ 


#ifndef TYPEDEFS_H_
#define TYPEDEFS_H_
  
  typedef unsigned int uint;
  typedef unsigned char uchar;
  typedef unsigned long ulong;
  typedef signed char schar;
  typedef unsigned short ushort;
  typedef unsigned int BOOL;

  typedef unsigned long long u64;
  typedef signed long long s64;

  typedef uint8_t BYTE;
  typedef uint16_t WORD;
  typedef uint32_t DWORD;
  typedef uint64_t ULONGLONG;

  typedef uint8_t UINT8;
  typedef uint16_t UINT16;
  typedef uint32_t UINT32;
  typedef uint64_t UINT64;

  typedef int8_t INT8;
  typedef int16_t INT16;
  typedef int32_t INT32;
  typedef int64_t INT64;

  typedef uint8_t UCHAR;
  typedef uint16_t USHORT;
  typedef uint32_t ULONG;

  typedef float FLOAT32;

#ifndef TRUE
  #define TRUE 0x01
#endif
#ifndef FALSE  
  #define FALSE 0x00
#endif

  // bit constants
  #define D0              (1UL<<0)
  #define D1              (1UL<<1)
  #define D2              (1UL<<2)
  #define D3              (1UL<<3)
  #define D4              (1UL<<4)
  #define D5              (1UL<<5)
  #define D6              (1UL<<6)
  #define D7              (1UL<<7)
  #define D8              (1UL<<8)
  #define D9              (1UL<<9)
  #define D10             (1UL<<10)
  #define D11             (1UL<<11)
  #define D12             (1UL<<12)
  #define D13             (1UL<<13)
  #define D14             (1UL<<14)
  #define D15             (1UL<<15)
  #define D16             (1UL<<16)
  #define D17             (1UL<<17)
  #define D18             (1UL<<18)
  #define D19             (1UL<<19)
  #define D20             (1UL<<20)
  #define D21             (1UL<<21)
  #define D22             (1UL<<22)
  #define D23             (1UL<<23)
  #define D24             (1UL<<24)
  #define D25             (1UL<<25)
  #define D26             (1UL<<26)
  #define D27             (1UL<<27)
  #define D28             (1UL<<28)
  #define D29             (1UL<<29)
  #define D30             (1UL<<30)
  #define D31             (1UL<<31)

  #define BV(x) (1UL<<(x))

#endif /* TYPEDEFS_H_ */